import argparse

def parse_arguments():
    parser = argparse.ArgumentParser(description='Training Script Parameters')

    # Define all the parameters
    parser.add_argument('--dataset_name', type=str, required=True, help='Dataset name as JSON string')
    parser.add_argument('--class_distribution', type=str, required=True, help='Class distribution')
    parser.add_argument('--Dirichlet_alpha', type=float, required=True, help='Dirichlet alpha')
    parser.add_argument('--handcrafted_order', type=int, required=True, help='Handcrafted order')
    parser.add_argument('--randomly_select_order', type=int, required=True, help='Randomly select order')
    parser.add_argument('--alternating_order', type=int, required=True, help='Alternating order')
    parser.add_argument('--sync_num_training', type=int, required=True, help='Sync number of training')
    parser.add_argument('--max_num_client', type=int, required=True, help='Max number of clients')
    parser.add_argument('--max_num_client_per_round', type=int, required=True, help='Max Number of clients per round')
    parser.add_argument('--min_num_client_per_round', type=int, required=True, help='Min Number of clients per round')
    parser.add_argument('--num_of_iterations_client_fixed_warm', type=int, required=True, help='Number of iterations client fixed warm')
    parser.add_argument('--num_of_iterations_client_fixed_apply', type=int, required=True, help='Number of iterations client fixed apply')
    parser.add_argument('--num_of_set_of_device_to_average_warm_model', type=int, required=True, help='Number of sets of device to average warm model')
    parser.add_argument('--SVHN_lr', type=float, required=True, help='SVHN learning rate')
    parser.add_argument('--mnist_lr', type=float, required=True, help='MNIST learning rate')
    parser.add_argument('--fmnist_lr', type=float, required=True, help='FMNIST learning rate')
    parser.add_argument('--cifar10_lr', type=float, required=True, help='CIFAR10 learning rate')
    parser.add_argument('--cifar100_lr', type=float, required=True, help='CIFAR100 learning rate')
    parser.add_argument('--cifar_model', type=str, required=True, help='CIFAR model')
    parser.add_argument('--momentum', type=float, required=True, help='Momentum')
    parser.add_argument('--gpu_index', type=int, required=True, help='GPU index')
    parser.add_argument('--num_SGD_training', type=int, required=True, help='Number of SGD trainings')
    parser.add_argument('--batch_size_training', type=int, required=True, help='Batch size for training')
    parser.add_argument('--num_SGD_grad_cal', type=int, required=True, help='Number of SGD gradient calculations')
    parser.add_argument('--batch_size_grad_cal', type=int, required=True, help='Batch size for gradient calculation')
    parser.add_argument('--footprint_fl', type=int, required=True, help='Footprint FL')
    parser.add_argument('--footprint_num_iteration', type=int, required=True, help='Footprint number of iterations')
    parser.add_argument('--regularized_or_not', type=int, required=True, help='Regularized or not')
    parser.add_argument('--trained_pilot_grad_or_not', type=int, required=True, help='Trained pilot gradient or not')
    parser.add_argument('--fixed_pilot_grad_or_not', type=int, required=True, help='Fixed pilot gradient or not')
    parser.add_argument('--trained_pilot_diff_as_grad_or_not', type=int, required=True, help='Trained pilot diff as gradient or not')
    parser.add_argument('--test_cold_model', type=int, required=True, help='Test cold model')
    parser.add_argument('--similarity', type=str, required=True, help='Similarity measure')
    parser.add_argument('--similarity_scale', type=float, required=True, help='Similarity scale')

    args = parser.parse_args()
    return args
